#include "cdiCan.def" 	// Can card definition

/*------------------------------------
 * CANopen commandos(ID) and objects
 *------------------------------------ */
#define SDO_TRANSMIT 0x600 /* request on remote node (read or write) */
#define SDO_RECEIVE 0x580 /* device back command on sdo_transmit(read or write) */
#define PDO_TRANSMIT 0x200 /* send without answer */
#define PDO2_TRANSMIT 0x300 /* send without answer */
#define PDO_DI_READ 0x180 /* digital input (read) */
#define PDO_AI_READ 0x280 /* analog input (read) */
#define NMT_COMMANDS 0x0
#define NMT_ERROS 0x700 /* from remote device */
#define EMERGENCE_MESSAGE 0x80 /* from remote device */

#define SDO_DIGI_OUTPUT_16_WR (SDO_TRANSMIT + 0x1) /* digital 16 bits out */
#define SDO_DIGI_OUTPUT_16_RD (SDO_TRANSMIT + 0x2) /* digital 16 bits read */
#define SDO_DIGI_OUTPUT_8_WR (SDO_TRANSMIT + 0x3) /* digital 8 bits out */
#define SDO_DIGI_OUTPUT_8_RD (SDO_TRANSMIT + 0x4) /* digital 8 bits read */

#define SDO_WRITE 0x22 /* sub command for SDO_TRANSMIT */
#define SDO_READ 0x40

#define SDO_DIGI_OUT_BYTE_OBJ 0x6200 /* object */
#define SDO_DIGI_OUT_OBJ 0x6300
#define SDO_TRANS_PDO_OBJ 0x1800
#define SDO_RECV_PDO_OBJ 0x1400

#define SDO_DESY_3000_OBJ 0x3000
#define SDO_DESY_3001_OBJ 0x3001

#define NMT_START_REMOTE 0x1         /* NMT data byte */
#define NMT_STOP_REMOTE 0x2
#define NMT_ENTER_PREOPERATION 0x80
#define NMT_RESET_NODE 0x81
#define NMT_RESET_COMMUNICATION 0x82

#define MAX_CAN_IDS	    128       // # number of CanOpen IDs enabled for receive 0x7f

#ifdef JANZCAN_H_
#define CAN_LIB_NAME  "CANJANZ"
#endif /* JANZCAN_H_ */

#ifdef ESDCAN_H_
#define CAN_LIB_NAME  "CANESD"
#endif /* ESDCAN_H_ */

#ifdef PEAKCAN_H_
#define CAN_LIB_NAME  "CANPEAK"
#endif /* PEAKCAN_H_ */

#ifdef PEAKCANLINUX_H_
#define CAN_LIB_NAME  "CANPEAK"
#endif /* PEAKCANLINUX_H_ */
