#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include <stdarg.h>
#include <math.h>
#include <errno.h>
#include "toolkit.h"
#include "tine.h"
#include "cdi.h"
#include "tinecdi.h"
#include "cdiSedacPKTRLib.h"

int cdiInitSedac(void)
{
  int cc = 0;

  if ((cc=cdiRegisterBusFilter("SEDACPKTR",filterSedacBus)) != 0 ) goto err;
  if ((cc=cdiRegisterBusInitialization("SEDACPKTR",initSedacForCDI)) != 0 ) goto err;
  if ((cc=cdiRegisterBusHandler("SEDACPKTR",execSedacBus)) != 0 ) goto err;
  if ((cc=cdiRegisterBusCleanup("SEDACPKTR",exitSedac)) != 0 ) goto err;
  if ((cc=cdiRegisterBusScanner("SEDACPKTR",sedacScanFcn)) != 0 ) goto err;

err:
  if (cc)
  {
    cdilog("%s : failure in bus registration SEDACPKTR",erlst[cc]);
  }
  return cc;
}

BOOL WINAPI DllMain(HINSTANCE hInstDll,DWORD fdwReason,LPVOID lpvReserved)
{ int i;
  switch (fdwReason)
  {
    case DLL_PROCESS_ATTACH:  // DLL being loaded
      cdiInitSedac();
      break;
    case DLL_THREAD_ATTACH:
      break;
    case DLL_THREAD_DETACH:
      break;
    case DLL_PROCESS_DETACH:  // DLL being unloaded
      for (i=1; i<=N_SEDAC_LINES; i++) exitSedac(i);
      break;
  }
  return (TRUE);
}
