#ifndef CDI_TWINCAT_H_
#define CDI_TWINCAT_H_

__declspec(dllexport) int filterTwinCAT(int *parameter, int accessFlag);
__declspec(dllexport) int initTwinCATcdi(int busLine, int cdiLine, int numberDevices, char *parameterList);
__declspec(dllexport) void execTwinCAT(CdiRequestInfoBlk *pReq);
__declspec(dllexport) int exitTwinCAT(int ln);
__declspec(dllexport) int doTwinCATRequest(CdiRequestInfoBlk *pReq, int step);
__declspec(dllexport) int waitTwinCATfinished(void);
__declspec(dllexport) int initTwinCAT(int ln, CdiRequestInfoBlk *pReq);
__declspec(dllexport) int twinCatScanFcn(char *target,char *result,int resultBufferSize);
__declspec(dllexport) int twinCatBlockTrans(int *requestIndex, int numberRequest, void **blockBuffer, int openFlag);

#define ADSIGRP_MB  0x4020

/* important notice for cdiaddr.csv !!!
subAddrIndex : access mode, value defined in twinADSaccessGrp[];
caAddrIndex : 
	if mode is ADSIGRP_SYM_VALBYHND, then it is index number for changing plc vrible names
	else then it is base address for this access mode
memOffset: is the memory offset for the access mode
paraGroupIndex: should be 0 always! store the handle for mode of ADSIGRP_SYM_VALBYHND  	
*/
enum twinCatParamIndex
{
  paraPortNumber,   /* sps port number; or SPS runtimeSystem number 1-4  */
  paraNetId,        /* sps NetId => 6 intergers */
  memOffset = 7,
  paraGroupIndex,
  paraiGroup,
  paraiOffs,
  paraSize,

};

typedef struct dataPar
	{
		unsigned long		indexGroup;	// index group in ADS server interface
		unsigned long		indexOffset;	// index offset in ADS server interface
		unsigned long		length;		// count of bytes to read
	} TDataPar;

typedef struct
{
  TDataPar *twinCatMem;
  unsigned char *mAdsSumBufferRes;
  int *reqList;
  int numRequests, reqSize, reqTotalSize;
} TwinCatBlock;

#endif /* CDI_TWINCAT_H_ */
